/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package consoleengcalculator;

/**
 *
 * @author simone
 */
public class CartesianPlane {
    public final static float MAXHUE = 0.9f;//MINHUE is 0

    private double xMin, xMax, yMin, yMax, cMin, cMax, xTick, yTick;
    private boolean showAxes, showTick, showTickLabels, showDrawLabels;
    private double panelWidthRatio, panelHeightRatio, colorRatio;
    private int backgroundCI, axesCI, gridCI;

    public CartesianPlane(double xMin, double xMax, double yMin, double yMax, double cMin, double cMax, double xTick, double yTick, boolean showAxes, boolean showTick, boolean showTickLabels, boolean showDrawLabels, int backgroundCI, int axesCI, int gridCI) {
        this.xMin = xMin;
        this.xMax = xMax;
        this.yMin = yMin;
        this.yMax = yMax;
        this.cMin = cMin;
        this.cMax = cMax;
        this.xTick = xTick;
        this.yTick = yTick;
        this.showAxes = showAxes;
        this.showTick = showTick;
        this.showTickLabels = showTickLabels;
        this.showDrawLabels = showDrawLabels;
        this.backgroundCI = backgroundCI;
        this.axesCI = axesCI;
        this.gridCI = gridCI;
        colorRatio = MAXHUE/(cMax - cMin);//sinc hue 0 is == hue 1 I decided to go up to MAXHUE
    }

    public boolean isShowAxes() {
        return showAxes;
    }

    public boolean isShowDrawLabels() {
        return showDrawLabels;
    }

    public boolean isShowGrid() {
        return showTick;
    }

    public boolean isShowTickLabels() {
        return showTickLabels;
    }

    public double getXMax() {
        return xMax;
    }

    public double getXMin() {
        return xMin;
    }

    public double getWidth () {
        return xMax-xMin;
    }

    public double getXTick() {
        return xTick;
    }

    public double getYMax() {
        return yMax;
    }

    public double getYMin() {
        return yMin;
    }

    public double getHeight () {
        return yMax-yMin;
    }

    public double getYTick() {
        return yTick;
    }

    public double getCMax() {
        return cMax;
    }

    public double getCMin() {
        return cMin;
    }

    public int getAxesCI() {
        return axesCI;
    }

    public int getBackgroundCI() {
        return backgroundCI;
    }

    public int getGridCI() {
        return gridCI;
    }

    public void setPanelHeightRatio (double panelHeight) {
        panelHeightRatio = panelHeight/getHeight();
    }

    public void setPanelWidthRatio(double panelWidth) {
        panelWidthRatio = panelWidth/getWidth();
    }

    public int transformX (double x) {
        return (int) (panelWidthRatio * (x - xMin));
    }

    public int transformY (double y) {
        return (int) (panelHeightRatio * (- y + yMax));
    }

    public float transformC (double c) {
        if (c < cMin) return 0f;
        if (c > cMax) return MAXHUE;
        return (float) (colorRatio * (c-cMin));
    }
    
    public int zoomX (double x) {
        return (int) (panelWidthRatio * x);
    }

    public int zoomY (double y) {
        return (int) (panelHeightRatio * y);
    }
    
}
