/*
 * ConsoleEngCalculatorView.java
 */

package consoleengcalculator;

import engcalculator.Calculator;
import engcalculator.CalculatorThread;
import engcalculator.AsynchronousOutput;
import engcalculator.function.Function;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.text.BadLocationException;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.LinkedList;
import javax.swing.text.StyledDocument;
import javax.swing.*;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;

/**
 * The application's main frame.
 */
public class ConsoleEngCalculatorView extends FrameView implements AsynchronousOutput {

    public ConsoleEngCalculatorView(SingleFrameApplication app) {
        super(app);

        initComponents();
        jFileChooser = new JFileChooser();
        EngCalcFileFilter eff = new EngCalcFileFilter();
        jFileChooser.addChoosableFileFilter(eff);
        jFileChooser.setFileFilter(eff);

        printOutput(calculator.compute("about").substring(9)+"\n", "bold");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        outputPane = new javax.swing.JScrollPane();
        outputTextPane = new javax.swing.JTextPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        inputTextArea = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu jMenuFile = new javax.swing.JMenu();
        jMenuItemLoad = new javax.swing.JMenuItem();
        jMenuItemSave = new javax.swing.JMenuItem();
        jMenuItemSaveAs = new javax.swing.JMenuItem();
        javax.swing.JMenuItem jMenuItemExit = new javax.swing.JMenuItem();
        jMenuEdit = new javax.swing.JMenu();
        jMenuPrevius = new javax.swing.JMenuItem();
        jMenuNext = new javax.swing.JMenuItem();
        jMenuHistory = new javax.swing.JMenuItem();
        jMenuDelete = new javax.swing.JMenuItem();
        jMenuItemClean = new javax.swing.JMenuItem();
        jMenuItemSuggest = new javax.swing.JMenuItem();
        jMenuItemNewLine = new javax.swing.JMenuItem();
        jMenuCalculator = new javax.swing.JMenu();
        jMenuItemDraw = new javax.swing.JMenuItem();
        jMenuItemBreak = new javax.swing.JMenuItem();
        javax.swing.JMenu jMenuHelp = new javax.swing.JMenu();
        jMenuItemHelp = new javax.swing.JMenuItem();
        javax.swing.JMenuItem jMenuItemAbout = new javax.swing.JMenuItem();

        mainPanel.setName("mainPanel"); // NOI18N

        outputPane.setName("outputPane"); // NOI18N

        outputTextPane.setEditable(false);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(consoleengcalculator.ConsoleEngCalculatorApp.class).getContext().getResourceMap(ConsoleEngCalculatorView.class);
        outputTextPane.setFont(resourceMap.getFont("outputTextPane.font")); // NOI18N
        outputTextPane.setName("outputTextPane"); // NOI18N
        outputPane.setViewportView(outputTextPane);

        jPanel1.setName("jPanel1"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        inputTextArea.setColumns(20);
        inputTextArea.setFont(resourceMap.getFont("inputTextArea.font")); // NOI18N
        inputTextArea.setTabSize(0);
        inputTextArea.setText(resourceMap.getString("inputTextArea.text")); // NOI18N
        inputTextArea.setName("inputTextArea"); // NOI18N
        inputTextArea.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                inputTextAreaKeyTyped(evt);
            }
            public void keyPressed(java.awt.event.KeyEvent evt) {
                inputTextAreaKeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(inputTextArea);

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 49, Short.MAX_VALUE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(outputPane, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 745, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(outputPane, javax.swing.GroupLayout.DEFAULT_SIZE, 270, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        menuBar.setName("menuBar"); // NOI18N

        jMenuFile.setText(resourceMap.getString("jMenuFile.text")); // NOI18N
        jMenuFile.setName("jMenuFile"); // NOI18N

        jMenuItemLoad.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_L, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemLoad.setText(resourceMap.getString("jMenuItemLoad.text")); // NOI18N
        jMenuItemLoad.setName("jMenuItemLoad"); // NOI18N
        jMenuItemLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemLoadActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemLoad);

        jMenuItemSave.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemSave.setText(resourceMap.getString("jMenuItemSave.text")); // NOI18N
        jMenuItemSave.setName("jMenuItemSave"); // NOI18N
        jMenuItemSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSaveActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemSave);

        jMenuItemSaveAs.setText(resourceMap.getString("jMenuItemSaveAs.text")); // NOI18N
        jMenuItemSaveAs.setName("jMenuItemSaveAs"); // NOI18N
        jMenuItemSaveAs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSaveAsActionPerformed(evt);
            }
        });
        jMenuFile.add(jMenuItemSaveAs);

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(consoleengcalculator.ConsoleEngCalculatorApp.class).getContext().getActionMap(ConsoleEngCalculatorView.class, this);
        jMenuItemExit.setAction(actionMap.get("quit")); // NOI18N
        jMenuItemExit.setName("jMenuItemExit"); // NOI18N
        jMenuFile.add(jMenuItemExit);

        menuBar.add(jMenuFile);

        jMenuEdit.setText(resourceMap.getString("jMenuEdit.text")); // NOI18N
        jMenuEdit.setName("jMenuEdit"); // NOI18N

        jMenuPrevius.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_UP, java.awt.event.InputEvent.CTRL_MASK));
        jMenuPrevius.setText(resourceMap.getString("jMenuPrevius.text")); // NOI18N
        jMenuPrevius.setName("jMenuPrevius"); // NOI18N
        jMenuPrevius.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuPreviusActionPerformed(evt);
            }
        });
        jMenuEdit.add(jMenuPrevius);

        jMenuNext.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_DOWN, java.awt.event.InputEvent.CTRL_MASK));
        jMenuNext.setText(resourceMap.getString("jMenuNext.text")); // NOI18N
        jMenuNext.setName("jMenuNext"); // NOI18N
        jMenuNext.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuNextActionPerformed(evt);
            }
        });
        jMenuEdit.add(jMenuNext);

        jMenuHistory.setText(resourceMap.getString("jMenuHistory.text")); // NOI18N
        jMenuHistory.setName("jMenuHistory"); // NOI18N
        jMenuHistory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuHistoryActionPerformed(evt);
            }
        });
        jMenuEdit.add(jMenuHistory);

        jMenuDelete.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_ESCAPE, java.awt.event.InputEvent.CTRL_MASK));
        jMenuDelete.setText(resourceMap.getString("jMenuDelete.text")); // NOI18N
        jMenuDelete.setName("jMenuDelete"); // NOI18N
        jMenuDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuDeleteActionPerformed(evt);
            }
        });
        jMenuEdit.add(jMenuDelete);

        jMenuItemClean.setText(resourceMap.getString("jMenuItemClean.text")); // NOI18N
        jMenuItemClean.setName("jMenuItemClean"); // NOI18N
        jMenuItemClean.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemCleanActionPerformed(evt);
            }
        });
        jMenuEdit.add(jMenuItemClean);

        jMenuItemSuggest.setText(resourceMap.getString("jMenuItemSuggest.text")); // NOI18N
        jMenuItemSuggest.setName("jMenuItemSuggest"); // NOI18N
        jMenuItemSuggest.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSuggestActionPerformed(evt);
            }
        });
        jMenuEdit.add(jMenuItemSuggest);

        jMenuItemNewLine.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_ENTER, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemNewLine.setText(resourceMap.getString("jMenuItemNewLine.text")); // NOI18N
        jMenuItemNewLine.setName("jMenuItemNewLine"); // NOI18N
        jMenuItemNewLine.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemNewLineActionPerformed(evt);
            }
        });
        jMenuEdit.add(jMenuItemNewLine);

        menuBar.add(jMenuEdit);

        jMenuCalculator.setText(resourceMap.getString("jMenuCalculator.text")); // NOI18N
        jMenuCalculator.setName("jMenuCalculator"); // NOI18N

        jMenuItemDraw.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_D, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemDraw.setText(resourceMap.getString("jMenuItemDraw.text")); // NOI18N
        jMenuItemDraw.setName("jMenuItemDraw"); // NOI18N
        jMenuItemDraw.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemDrawActionPerformed(evt);
            }
        });
        jMenuCalculator.add(jMenuItemDraw);

        jMenuItemBreak.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_B, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemBreak.setText(resourceMap.getString("jMenuItemBreak.text")); // NOI18N
        jMenuItemBreak.setName("jMenuItemBreak"); // NOI18N
        jMenuItemBreak.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemBreakActionPerformed(evt);
            }
        });
        jMenuCalculator.add(jMenuItemBreak);

        menuBar.add(jMenuCalculator);

        jMenuHelp.setText(resourceMap.getString("jMenuHelp.text")); // NOI18N
        jMenuHelp.setName("jMenuHelp"); // NOI18N

        jMenuItemHelp.setText(resourceMap.getString("jMenuItemHelp.text")); // NOI18N
        jMenuItemHelp.setName("jMenuItemHelp"); // NOI18N
        jMenuItemHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemHelpActionPerformed(evt);
            }
        });
        jMenuHelp.add(jMenuItemHelp);

        jMenuItemAbout.setText(resourceMap.getString("jMenuItemAbout.text")); // NOI18N
        jMenuItemAbout.setName("jMenuItemAbout"); // NOI18N
        jMenuItemAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAboutActionPerformed(evt);
            }
        });
        jMenuHelp.add(jMenuItemAbout);

        menuBar.add(jMenuHelp);

        setComponent(mainPanel);
        setMenuBar(menuBar);
    }// </editor-fold>//GEN-END:initComponents

    private void inputTextAreaKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_inputTextAreaKeyPressed
        if (evt.isControlDown()) {
            switch (evt.getKeyCode()) {
//                case KeyEvent.VK_DOWN:
//                    nextHistory();
//                    break;
//                case KeyEvent.VK_UP:
//                    previousHistory ();
//                    break;
//                case KeyEvent.VK_ESCAPE:
//                    deleteFromHistory();
//                    break;
                case KeyEvent.VK_H:
                    showHistory ();
                    break;
//                case KeyEvent.VK_ENTER:
//                    appendNewLine();
//                    break;
            }
        } else {
            switch (evt.getKeyCode()) {
                case KeyEvent.VK_ENTER:
                    evaluateLine ();
                    break;
                case KeyEvent.VK_ESCAPE:
                    inputTextArea.setText("");
                    break;
            }
        }
    }//GEN-LAST:event_inputTextAreaKeyPressed

    private void inputTextAreaKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_inputTextAreaKeyTyped
        if (evt.isControlDown()) return;
        switch (evt.getKeyChar()) {
            case '\n':
                inputTextArea.setText(inputTextAreaFiller);
                break;
            case '\t':
                suggestFunctionOrVariable();
                break;
        }
    }//GEN-LAST:event_inputTextAreaKeyTyped

    private void jMenuItemBreakActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemBreakActionPerformed
        if (calculatorThread != null && calculatorThread.getState() == Thread.State.RUNNABLE) {
            calculatorThread.stopCalculus();
            printOutput("The last operation was aborted.\n","regular");
        }
    }//GEN-LAST:event_jMenuItemBreakActionPerformed

    private void jMenuItemAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAboutActionPerformed
        if (aboutBox == null) {
            JFrame mainFrame = ConsoleEngCalculatorApp.getApplication().getMainFrame();
            aboutBox = new ConsoleEngCalculatorAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        aboutBox.setVisible(true);
    }//GEN-LAST:event_jMenuItemAboutActionPerformed

    private void jMenuItemDrawActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemDrawActionPerformed
        if (drawBox == null) drawBox = new ConsoleEngCalculatorDrawBox();
        drawBox.setVisible(true);
    }//GEN-LAST:event_jMenuItemDrawActionPerformed

    private void jMenuItemHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemHelpActionPerformed
        if (helpBox == null) {
            JFrame mainFrame = ConsoleEngCalculatorApp.getApplication().getMainFrame();
            helpBox = new ConsoleEngCalculatorHelpBox(mainFrame);
            helpBox.setLocationRelativeTo(mainFrame);
        }
        helpBox.setVisible(true);
    }//GEN-LAST:event_jMenuItemHelpActionPerformed

    private void jMenuItemLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemLoadActionPerformed
        int res = jFileChooser.showOpenDialog(this.getComponent());
        if (res == JFileChooser.APPROVE_OPTION) {
            workingFile = jFileChooser.getSelectedFile();
            loadHistoryFile();
        }
    }//GEN-LAST:event_jMenuItemLoadActionPerformed

    private void jMenuItemSaveAsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSaveAsActionPerformed
        int res = jFileChooser.showSaveDialog(this.getComponent());
        if (res == JFileChooser.APPROVE_OPTION) {
            workingFile = jFileChooser.getSelectedFile();
            saveHistoryFile();
        }
    }//GEN-LAST:event_jMenuItemSaveAsActionPerformed

    private void jMenuItemSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSaveActionPerformed
        if (workingFile != null) saveHistoryFile();
        else jMenuItemSaveAsActionPerformed(null);
    }//GEN-LAST:event_jMenuItemSaveActionPerformed

    private void jMenuPreviusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuPreviusActionPerformed
        previousHistory();
    }//GEN-LAST:event_jMenuPreviusActionPerformed

    private void jMenuNextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuNextActionPerformed
        nextHistory();
    }//GEN-LAST:event_jMenuNextActionPerformed

    private void jMenuHistoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuHistoryActionPerformed
        showHistory();
    }//GEN-LAST:event_jMenuHistoryActionPerformed

    private void jMenuDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuDeleteActionPerformed
        deleteFromHistory();
    }//GEN-LAST:event_jMenuDeleteActionPerformed

    private void jMenuItemCleanActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemCleanActionPerformed
        inputTextArea.setText("");
    }//GEN-LAST:event_jMenuItemCleanActionPerformed

    private void jMenuItemSuggestActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSuggestActionPerformed
        suggestFunctionOrVariable();
    }//GEN-LAST:event_jMenuItemSuggestActionPerformed

    private void jMenuItemNewLineActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemNewLineActionPerformed
        appendNewLine();
    }//GEN-LAST:event_jMenuItemNewLineActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea inputTextArea;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JMenu jMenuCalculator;
    private javax.swing.JMenuItem jMenuDelete;
    private javax.swing.JMenu jMenuEdit;
    private javax.swing.JMenuItem jMenuHistory;
    private javax.swing.JMenuItem jMenuItemBreak;
    private javax.swing.JMenuItem jMenuItemClean;
    private javax.swing.JMenuItem jMenuItemDraw;
    private javax.swing.JMenuItem jMenuItemHelp;
    private javax.swing.JMenuItem jMenuItemLoad;
    private javax.swing.JMenuItem jMenuItemNewLine;
    private javax.swing.JMenuItem jMenuItemSave;
    private javax.swing.JMenuItem jMenuItemSaveAs;
    private javax.swing.JMenuItem jMenuItemSuggest;
    private javax.swing.JMenuItem jMenuNext;
    private javax.swing.JMenuItem jMenuPrevius;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JScrollPane outputPane;
    private javax.swing.JTextPane outputTextPane;
    // End of variables declaration//GEN-END:variables

    //User Variable declaration;
    private ArrayList<String> inputStrings=new ArrayList<String>();
    private int scrollingIndex=-1;

    private JDialog aboutBox, helpBox;
    private JFrame drawBox;
    private Calculator calculator = new Calculator();
    private CalculatorThread calculatorThread;
    private String inputTextAreaFiller = "";

    private JFileChooser jFileChooser;
    private File workingFile = null;

    private void saveHistoryFile () {
        try {
            if (workingFile.exists()) workingFile.delete();
            workingFile.createNewFile();

            FileOutputStream fos = new FileOutputStream (workingFile);

            for (String s : inputStrings) {
                for (char c : s.toCharArray())
                    fos.write(c);
                fos.write('\n');
            }

            fos.close();

        } catch (Exception e) {
            printOutput("It was not possible to save the file: "+e.toString()+"\n","regular");
        }
    }

    private void evaluateLine() {
        if (calculatorThread != null && calculatorThread.getState() == Thread.State.RUNNABLE) {
            printOutput("Wait please, the calculator is computing...\n","regular");
            return;
        }

        String inputline;

        inputline=inputTextArea.getText();
        inputline=inputline.trim();
        int prevLength = inputline.length();
        inputline=addMissingEndingChars(inputline);
        
        if (prevLength != inputline.length()) {
            inputTextAreaFiller = inputline;
            return;
        } else inputTextAreaFiller = "";

        inputStrings.add(inputline);
        scrollingIndex=-1;

        calculatorThread = new CalculatorThread(calculator, inputline, this);
    }

    private String addMissingEndingChars (String input) {
        StringBuffer inp = new StringBuffer (input);
        int open=0, closed=0, ap=0;
        for (char c : input.toCharArray())
            switch (c) {
                case '(':
                    ++open;
                    break;
                case ')':
                    ++closed;
                    break;
                case '\'':
                    ++ap;
                    open = closed = 0;
                    break;
            }

        if ((ap & 1) != 0) {
            while (open > closed) {
                inp.append(')');
                ++closed;
            }

            inp.append('\'');
        }

       open=closed=0;
        for (char c : inp.toString().toCharArray())
            switch (c) {
                case '(':
                    ++open;
                    break;
                case ')':
                    ++closed;
                    break;
            }


        while (open > closed) {
            inp.append(')');
            ++closed;
        }

        return inp.toString();
    }

    private void suggestFunctionOrVariable() {
        String inputline, outputline="", subset;
        String textleft, textright;
        LinkedList matchingList=new LinkedList();
        int i,j;
        LinkedList dataList=Function.getFunctionSymbols() ;
        
        //find the input string indexes
        textleft=inputTextArea.getText();
        j = textleft.indexOf("\t");
        if (j == -1) return;
        textright = textleft.substring(j+1);
        textleft = textleft.substring(0, j);

        j=textleft.length();
        i=j-1;
        while ( i>=0 && (Character.isLetter(textleft.charAt(i) ) || Character.isDigit(textleft.charAt(i)))) --i;
         
        inputline=textleft.substring(i+1,j).trim();
        matchingList=getMatch(inputline,dataList,true);
                
        if (matchingList.size()==1) {
            outputline=matchingList.getFirst().toString();
            
            printInputLine(i,outputline.concat(textright));
            inputTextArea.setCaretPosition(1+i+outputline.length());

        } else if (matchingList.size()>0) {
            subset=getSubset(inputline,matchingList);
            if (subset.length() ==inputline.length()) {
                for (int k=0; k < matchingList.size(); ++k) {
                        String s1 = matchingList.get(k).toString().concat(" - ");
                        if (s1 != null) outputline=outputline.concat(s1);
                    }
                printOutput("SUGGESTION: "+outputline+"\n","italic");
                printInputLine(-1,textleft.concat(textright));
                inputTextArea.setCaretPosition(textleft.length());
            } else {
                printInputLine(i,subset.concat(textright));
                inputTextArea.setCaretPosition(1+i+subset.length());
            }
            
        } else {
            printInputLine(-1,textleft.concat(textright));
            inputTextArea.setCaretPosition(textleft.length());
        }
  
    }

    private LinkedList getMatch(String s, LinkedList dataList,boolean isCaseSensitive) {
        LinkedList<String> mList=new LinkedList<String>();

        for (int i = 0; i < dataList.size(); i++) {
            String s1 = dataList.get(i).toString();
            if (s1 != null) {
                if (!isCaseSensitive
                    && s1.toLowerCase().startsWith(s.toLowerCase()))
                    mList.add(s1);
                if (isCaseSensitive && s1.startsWith(s))
                    mList.add(s1);
            }
        }
        return mList;
  }

    private String getSubset(String inputline, LinkedList matchingList) {
        String s=inputline;
        String s1=s;
        boolean equal=true;

        int j=s.length();
        while (equal==true) {
            s1=matchingList.getFirst().toString().substring(0, j);
            ++j;
            for (int k=0;k<matchingList.size();++k  ) {
                if (matchingList.get(k).toString().startsWith(s1)) equal=true;
                else {
                    equal=false;
                    break;
                }
            }
        }
        return s1.substring(0, j-2); 
    }

    @Override
    public void printOutput (String out, String style ) {
        StyledDocument outdoc = outputTextPane.getStyledDocument();
        Style def = StyleContext.getDefaultStyleContext().getStyle( StyleContext.DEFAULT_STYLE );
        Style s;
        Style regular = outdoc.addStyle( "regular", def );
        s=regular;
        // Create an italic style
        Style italic = outdoc.addStyle( "italic", regular );
        StyleConstants.setItalic(italic, true);

        Style bold = outdoc.addStyle( "bold", regular );
        StyleConstants.setBold( bold, true );
        if (style.equals("regular")) s=regular;
        if (style.equals("bold")) s=bold;
        if (style.equals("italic")) s=italic;
        try {
              outdoc.insertString(outdoc.getLength(), out, s);
            }
        catch (BadLocationException ex) {
              Logger.getLogger(ConsoleEngCalculatorView.class.getName()).log(Level.SEVERE, null, ex);
            }
        outputTextPane.setCaretPosition(outdoc.getLength());
    }

    private void printInputLine (int start,  String in ) {
       String inputline;
        
       inputline=inputTextArea.getText().substring(0, start+1);
       
       inputTextArea.setText(inputline+in);
    }

    private void nextHistory() {
        if (inputStrings.size() == 0) return;

        inputTextArea.setText("");        

        ++scrollingIndex;
        if (scrollingIndex >= inputStrings.size()) scrollingIndex=0;

        String inputLine=inputStrings.get(scrollingIndex).toString();
        printInputLine (-1, inputLine);
    }

    private void previousHistory() {
        if (inputStrings.size() == 0) return;
        
        inputTextArea.setText("");

        --scrollingIndex;
        if (scrollingIndex<0) scrollingIndex=inputStrings.size()-1;
        
        String inputLine=inputStrings.get(scrollingIndex).toString();
        printInputLine (-1, inputLine);      
    }

    private void deleteFromHistory () {
        if (scrollingIndex >= 0 && scrollingIndex < inputStrings.size()) {
            inputStrings.remove(scrollingIndex);

            while (scrollingIndex < 0) ++scrollingIndex;
            while (scrollingIndex >= inputStrings.size()) --scrollingIndex;
            
            inputTextArea.setText("");
        }
    }

    private void loadHistoryFile() {
        try {
            FileInputStream fis = new FileInputStream (workingFile);
            StringBuffer inputline = new StringBuffer (fis.available());

            while (fis.available()!=0) {
                inputline.append((char) fis.read());
            }

            fis.close();

            inputTextArea.setText(inputline.toString());
        } catch (Exception e) {
            printOutput("It was not possible to load the file. "+e.toString()+"\n","regular");
        }
    }

    private void showHistory() {
        printOutput ("History\n", "regular");
        StringBuffer history = new StringBuffer ();
        for (String s : inputStrings)
            history.append(s).append('\n');
        printOutput(history.toString(),"regular");
    }

    private void appendNewLine () {
        String in = inputTextArea.getText();
        int cp = inputTextArea.getCaretPosition();
        StringBuffer out = new StringBuffer(in.length()+1);
        out = out.append(in.substring(0, cp)).append("\n").append(in.substring(cp));
        inputTextArea.setText(out.toString());
    }
   
}
