/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression;

import engcalculator.data.IntervalList;
import engcalculator.function.Function;
import engcalculator.function.infix.InfixFunction;
import engcalculator.function.prefix.PrefixFunction;
import java.util.LinkedList;

/**
 *
 * @author simone
 */
public class Compiler extends Interpeter {
    private LinkedList<Function> functions;
    private LinkedList<IntervalList> data;

    public Compiler(TokenList tokenizedExpression) {
        super(tokenizedExpression);
        functions = new LinkedList<Function>();
        data = new LinkedList<IntervalList>();
    }

    @Override
    protected IntervalList computeInfixFunction(InfixFunction function, IntervalList argument1, IntervalList argument2) throws Exception {
        if (argument1 != null && argument1.getName() == null && argument2 != null && argument2.getName() == null) return function.compute(argument1, argument2); //optimization, not strictly required just faster compilation
        if (argument1 != null) data.addLast(argument1);
        if (argument2 != null) data.addLast(argument2);
        functions.addLast(function);
        return null;
    }

    @Override
    protected IntervalList computePrefixFunction(PrefixFunction function, IntervalList argument) throws Exception {
        if (argument != null && argument.getName() == null) return function.compute(argument);
        if (argument != null) data.addLast(argument);
        functions.addLast(function);
        return null;
    }

    public IntervalList compile() throws Exception {
        IntervalList last = super.parse();
        if (last != null) data.addLast(last);
        System.out.println("Data: "+data);
        System.out.println("Functions: "+functions);
        return null;
    }

    public IntervalList execute () throws Exception {
        LinkedList<Function> fTmp = new LinkedList<Function> (functions);
        LinkedList<IntervalList> dTmp = new LinkedList<IntervalList> (data);
        while (fTmp.size() > 0) {
            Function f = fTmp.pop();
            IntervalList[] arguments = new IntervalList[f.getNumberOfArguments()];
            for (int i = 0; i < arguments.length; ++i) arguments[i] = dTmp.pop();
            dTmp.push(f.compute(arguments));
        }
        if (dTmp.size() != 1) throw new Exception ("Wrong number of arguments found in the stack at the end of the operations, the partial results are: "+dTmp);
        return dTmp.getFirst();
    }

}
