/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression.token;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.expression.ParsingException;

/**
 *
 * @author simone
 */
public class IntervalTkn extends Token {

    private IntervalList intervalList;

    public IntervalTkn() {}

    private IntervalTkn(String interval) throws ParsingException {
        super (interval);
        this.intervalList = new IntervalList (Interval.valueOf(interval));
    }

    @Override
    public IntervalList getIntervalList() {
        return intervalList;
    }

    @Override
    public Token generateToken(String symbol) {
        try {
            return new IntervalTkn(symbol);
        } catch (Exception e) {
            return null;
        }
    }

    @Override
    public boolean mayBeCompatible(String symbol) {
        int digits = 0, points = 0;
        boolean exp = false, engcost = false, neg = false;//, tolerance = false;
        for (char c : symbol.toCharArray()) {
            if (Character.isDigit(c)) {
                ++digits;
            } else if (c == '.') {
                if (exp || points > 2) return false;
                else ++points;
            } else if (c == 'e') {
                if (exp || engcost || digits == 0) return false;
                else exp = true;
            } else if (c == '-') {
                if (!exp || neg || digits == 0) return false;
                else neg = true;
            } else if (Interval.ENGUNITS.indexOf(c) > -1) {
                if (engcost) return false;
                else engcost = true;
            } else {
                return false;
            }
        }
        return true;
    }

}
