/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix;

import engcalculator.data.IntervalList;
import engcalculator.data.Literal;
import engcalculator.data.NamedMatrixIntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.prefix.UserFunction;
import engcalculator.expression.Expression;
import engcalculator.variable.Variable;
import java.util.LinkedList;

/**
 *
 * @author simone
 */
public class Set extends InfixFunction {

    public Set() {
        super ("=", (byte) -1, (byte) -1, false, true, "Set a variable or a function value. Ex.: 'a'=(1,2,3%2) sets the variable a=(1,2,3%2), ('f','x','y')='x+y' sets the function f(x,y) = x+y, ('f','x'='x,2*x' set the function f which gets the parameter x and returns a list of two elements (x,2*x). Please note when a function or variable is defined all other variables involved (with exception of parameters) must be knonw because they are compiled.", null, null, null);
    }

    @Override
    public IntervalList _compute(IntervalList left, IntervalList right) throws Exception {
        if (left.size() < 1) throw new CalculusException ("It is expected a literal to be set as variable.");

        String fname = left.getName();
        boolean isvariable = true;
        if (fname == null) {
            fname = left.getFirst().getName();
            isvariable = false;
        }
        if (fname == null) throw new CalculusException ("It is expected a literal to be set as variable.");

        if (isvariable || left.size() == 1) {//variable definition
            
            Variable var = new Variable (fname, right, false, "User defined variable.");

            if (! Variable.addVariable(var)) throw new CalculusException ("There is a variable already defined with the same name which is constant");

            return new NamedMatrixIntervalList(var.getValue(), var.getSymbol());
        } else if (left.size() > 1) { //function definition
            LinkedList<String> varnames = new LinkedList<String> ();

            final int s = left.size();           
            for (int i=1; i<s; ++i) {
                String varname;
                varname = left.get(i).getName();
                if (varname == null) throw new CalculusException("It was expected a literal and not a number as a function definition variable");
                varnames.add(varname);
            }

            String fbody;
            if (right.size() > 1 || (fbody = right.getFirst().getName()) == null) throw new CalculusException("It was expected a literal showing the defined function operations.");
            Expression e;
            e = new Expression(fbody, varnames);

            StringBuffer help = new StringBuffer();
            help.append(left.getFirst().getName()).append('(');
            for (String v : varnames)
                help.append(v).append(',');

            help.setCharAt(help.length()-1, ')');
            help.append('=').append(e.toString());

            UserFunction f = new UserFunction (left.getFirst().getName(), (byte) (s-1), true, help.toString(), e, varnames);
            if (! PrefixFunction.addFunction(f)) throw new CalculusException ("There is a function already defined with the same name which is constant.");

            return new IntervalList (new Literal (f.getSymbol()));
        }
        throw new CalculusException("Not well formed setting.");
    }
}
