/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.interval;

import engcalculator.data.Interval;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public class Sign extends SingleInputSingleOutputPrefixFunction {
    private final static String[] EXAMPLE = {"-10_10, 5_7, -7_-5"};
    private final static String[] RESULT = {"0, 1, -1"};

    public Sign() {
        super("sign", true, true, "Returns -1, if A contains only negative values and 0; 1, if A contains only positive values and 0; 0 if A contains both positive and negative values or A is 0 or A involves NaN.", EXAMPLE, RESULT);
    }
    
    @Override
    public Interval _computeIntervals (Interval i) throws Exception {
        double a1 = i.getLeft(), a2 = i.getRight();
        if (a1 == 0 || a2 == 0 || Double.isNaN(a1) || Double.isNaN(a2)) return new Interval (0);
        if (i.isPositive()) return new Interval (1);
        if (i.isNegative()) return new Interval (-1);
        return new Interval (0);
    }
}
