/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.matrix;

import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class MatrixTranspose extends PrefixFunction {
    private final static String[] EXAMPLE = {"(1, 2, 3, 4)#2"};
    private final static String[] RESULT = {"(1, 3, 2, 4)#2"};

    public MatrixTranspose() {
        super("transpose", (byte) -1, false, true, "Transpose a matrix", EXAMPLE, RESULT);
    }


    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        if (! input.isMatrix()) throw new CalculusException ("It was expected a matrix as input");
        MatrixIntervalList inputMatrix = (MatrixIntervalList) input;
        final int rs = input.getRows(), cs = input.getColumns();
        MatrixIntervalList result = new MatrixIntervalList (rs);
        for (int c=0; c<cs; ++c)
            for (int r=0; r<rs; ++r)
                result.add(inputMatrix.get(r,c));
        return result;

    }

}
