/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.plot;

import engcalculator.function.prefix.space.LinSpace;
import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.infix.interval.IntervalByToleranceBuilder;

/**
 *
 * @author simone
 */
public class ParametricPlot extends PrefixFunction {
    private final static String[] EXAMPLE = {"(f,x)='(cos x, sin x)', 5, 0_2*pi, 0"};
    private final static String[] RESULT = {"((1,0,-1,0,1)#1 ,| (0,1,0,-1,0)#1)"};
    private final static LinSpace LIN_SPACE = new LinSpace();
    private final static IntervalByToleranceBuilder INTERVAL_BY_TOLERANCE_BUILDER = new IntervalByToleranceBuilder();

    public ParametricPlot () {
        super("parametricplot", (byte) 4, false, false, "parametricplot build an array which can later be used to plot the function. It requires a function returning a list of a couple of elements to compute x and y, the number of points, the interval range and the tolerance of those intervals use to compute the parametric variable.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        String fname = input.getFirst().getName();
        if (fname == null) throw new CalculusException ("It is expected a function name as first element");
        PrefixFunction fxy = PrefixFunction.getFunction(fname);
        if (fxy == null) throw new CalculusException ("It is not possible to find a function matching the given name");
        if (fxy.getNumbArgs() != 1) throw new CalculusException ("It is required a function of 1 argument");

        IntervalList t = INTERVAL_BY_TOLERANCE_BUILDER.compute(LIN_SPACE._compute(input.subList(1, 3)), new IntervalList(input.get(3)));

        //it is not used the property of function to work on list in order to skip the 'bad' values
        MatrixIntervalList xy = new MatrixIntervalList (2);
        for (int i=0; i<t.size(); ++i) {
            try {
                xy.addAll(fxy._compute(t.subList(i, i+1)));
            } catch (Exception ce) {
            }
        }

        return xy;
    }

}
